Poly1305TLS_Base Class Reference

Poly1305-TLS message authentication code base class. More...

`#include <poly1305.h>`

Inheritance diagram for Poly1305TLS_Base:

## Public Member Functions

void | UncheckedSetKey (const byte *key, unsigned int length, const NameValuePairs &params)
| Sets the key for this object without performing parameter validation.
void | Update (const byte *input, size_t length)
| Updates a hash with additional input.
void | TruncatedFinal (byte *mac, size_t size)
| Computes the hash of the current message.
void | Restart ()
| Restart the hash.
unsigned int | BlockSize () const
| Provides the block size of the compression function.
unsigned int | DigestSize () const
| Provides the digest size of the hash.
Public Member Functions inherited from SimpleKeyingInterface
virtual size_t | MinKeyLength () const =0
| Returns smallest valid key length.
virtual size_t | MaxKeyLength () const =0
| Returns largest valid key length.
virtual size_t | DefaultKeyLength () const =0
| Returns default key length.
virtual size_t | GetValidKeyLength (size_t keylength) const =0
| Returns a valid key length for the algorithm.
virtual bool | IsValidKeyLength (size_t keylength) const
| Returns whether keylength is a valid key length.
virtual void | SetKey (const byte *key, size_t length, const NameValuePairs &params=g_nullNameValuePairs)
| Sets or reset the key of this object.
void | SetKeyWithRounds (const byte *key, size_t length, int rounds)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv, size_t ivLength)
| Sets or reset the key of this object.
void | SetKeyWithIV (const byte *key, size_t length, const byte *iv)
| Sets or reset the key of this object.
virtual IV_Requirement | IVRequirement () const =0
| Minimal requirement for secure IVs.
bool | IsResynchronizable () const
| Determines if the object can be resynchronized.
bool | CanUseRandomIVs () const
| Determines if the object can use random IVs.
bool | CanUsePredictableIVs () const
| Determines if the object can use random but possibly predictable IVs.
bool | CanUseStructuredIVs () const
| Determines if the object can use structured IVs.
virtual unsigned int | IVSize () const
| Returns length of the IV accepted by this object.
unsigned int | DefaultIVLength () const
| Provides the default size of an IV.
virtual unsigned int | MinIVLength () const
| Provides the minimum size of an IV.
virtual unsigned int | MaxIVLength () const
| Provides the maximum size of an IV.
virtual void | Resynchronize (const byte *iv, int ivLength=-1)
| Resynchronize with an IV.
virtual void | GetNextIV (RandomNumberGenerator &rng, byte *iv)
| Retrieves a secure IV for the next message.
Public Member Functions inherited from HashTransformation
HashTransformation & | Ref ()
| Provides a reference to this object.
virtual byte * | CreateUpdateSpace (size_t &size)
| Request space which can be written into by the caller.
virtual void | Final (byte *digest)
| Computes the hash of the current message.
unsigned int | TagSize () const
| Provides the tag size of the hash.
virtual unsigned int | OptimalBlockSize () const
| Provides the input block size most efficient for this hash.
virtual unsigned int | OptimalDataAlignment () const
| Provides input and output data alignment for optimal performance.
virtual void | CalculateDigest (byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | Verify (const byte *digest)
| Verifies the hash of the current message.
virtual bool | VerifyDigest (const byte *digest, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
virtual void | CalculateTruncatedDigest (byte *digest, size_t digestSize, const byte *input, size_t length)
| Updates the hash with additional input and computes the hash of the current message.
virtual bool | TruncatedVerify (const byte *digest, size_t digestLength)
| Verifies the hash of the current message.
virtual bool | VerifyTruncatedDigest (const byte *digest, size_t digestLength, const byte *input, size_t length)
| Updates the hash with additional input and verifies the hash of the current message.
Public Member Functions inherited from Algorithm
| Algorithm (bool checkSelfTestStatus=true)
| Interface for all crypto algorithms.
virtual std::string | AlgorithmName () const
| Provides the name of this algorithm.
virtual std::string | AlgorithmProvider () const
| Retrieve the provider of this algorithm.
Public Member Functions inherited from Clonable
virtual Clonable * | Clone () const
| Copies this object.

## Static Public Member Functions

static std::string | StaticAlgorithmName ()
Static Public Member Functions inherited from FixedKeyLength< 32 >
static size_t | StaticGetValidKeyLength (size_t keylength)
| The default key length for the algorithm provided by a static function.

## Static Public Attributes

static const int | DIGESTSIZE =16
static const int | BLOCKSIZE =16
Static Public Attributes inherited from FixedKeyLength< 32 >
static const int | KEYLENGTH
| The default key length used by the algorithm provided as a constant.
static const int | MIN_KEYLENGTH
| The minimum key length used by the algorithm provided as a constant.
static const int | MAX_KEYLENGTH
| The maximum key length used by the algorithm provided as a constant.
static const int | DEFAULT_KEYLENGTH
| The default key length used by the algorithm provided as a constant.
static const int | IV_REQUIREMENT
| The default IV requirements for the algorithm provided as a constant.
static const int | IV_LENGTH
| The default IV length used by the algorithm provided as a constant.

## Additional Inherited Members

Public Types inherited from SimpleKeyingInterface
enum | IV_Requirement { UNIQUE_IV = 0 , RANDOM_IV , UNPREDICTABLE_RANDOM_IV , INTERNALLY_GENERATED_IV , NOT_RESYNCHRONIZABLE }
| Secure IVs requirements as enumerated values. More...

## Detailed Description

Poly1305-TLS message authentication code base class.

Poly1305TLS_Base is the base class of the IETF's Poly1305 algorithm.

Since
  Crypto++ 8.1

Definition at line 164 of file poly1305.h.

## Constructor & Destructor Documentation

## ~Poly1305TLS_Base()

virtual Poly1305TLS_Base::~Poly1305TLS_Base | ( |  | ) |

inline virtual

Definition at line 171 of file poly1305.h.

## Poly1305TLS_Base()

Poly1305TLS_Base::Poly1305TLS_Base | ( |  | ) |

inline

Definition at line 172 of file poly1305.h.

## Member Function Documentation

## StaticAlgorithmName()

std::string Poly1305TLS_Base::StaticAlgorithmName | ( |  | ) |

inline static

Definition at line 167 of file poly1305.h.

## UncheckedSetKey()

void Poly1305TLS_Base::UncheckedSetKey | ( | const byte * | key,
|  | unsigned int | length,
|  | const NameValuePairs & | params )

virtual

Sets the key for this object without performing parameter validation.

Parameters

  key | a byte buffer used to key the cipher
  length | the length of the byte buffer
  params | additional parameters passed as NameValuePairs

key must be at least DEFAULT_KEYLENGTH in length.

Implements SimpleKeyingInterface.

Definition at line 315 of file poly1305.cpp.

## Update()

void Poly1305TLS_Base::Update | ( | const byte * | input,
|  | size_t | length )

virtual

Updates a hash with additional input.

Parameters

  input | the additional input as a buffer
  length | the size of the buffer, in bytes

Implements HashTransformation.

Definition at line 335 of file poly1305.cpp.

## TruncatedFinal()

void Poly1305TLS_Base::TruncatedFinal | ( | byte * | digest,
|  | size_t | digestSize )

virtual

Computes the hash of the current message.

Parameters

  digest | a pointer to the buffer to receive the hash
  digestSize | the size of the truncated digest, in bytes

TruncatedFinal() calls Final() and then copies digestSize bytes to digest. The hash is restarted the hash for the next message.

Precondition
  COUNTOF(digest) <= DigestSize() or COUNTOF(digest) <= HASH::DIGESTSIZE ensures the output byte buffer is a valid size.

Implements HashTransformation.

Definition at line 374 of file poly1305.cpp.

## Restart()

void Poly1305TLS_Base::Restart | ( |  | ) |

virtual

Restart the hash.

Discards the current state, and restart for a new message

Reimplemented from HashTransformation.

Definition at line 394 of file poly1305.cpp.

## BlockSize()

unsigned int Poly1305TLS_Base::BlockSize | ( |  | ) | const

inline virtual

Provides the block size of the compression function.

Returns
  block size of the compression function, in bytes

BlockSize() will return 0 if the hash is not block based or does not have an equivalent block size. For example, Keccak and SHA-3 do not have a block size, but they do have an equivalent block size called rate expressed as r.

Reimplemented from HashTransformation.

Definition at line 179 of file poly1305.h.

## DigestSize()

unsigned int Poly1305TLS_Base::DigestSize | ( |  | ) | const

inline virtual

Provides the digest size of the hash.

Returns
  the digest size of the hash.

Implements HashTransformation.

Definition at line 180 of file poly1305.h.

## Member Data Documentation

## DIGESTSIZE

const int Poly1305TLS_Base::DIGESTSIZE =16

static

Definition at line 168 of file poly1305.h.

## BLOCKSIZE

const int Poly1305TLS_Base::BLOCKSIZE =16

static

Definition at line 169 of file poly1305.h.

The documentation for this class was generated from the following files:

- poly1305.h
- poly1305.cpp